/***************************************************************************
Name: Less Spam, please
Version: 0.4.1
Description: Temporary mail address generator
Author: Benoit Bailleux
Homepage: -
Email:  skrypz42@yahoo.fr

Copyright (C) 2010 Benoit Bailleux

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

Free Software Foundation, Inc.
51 Franklin Street
Fifth Floor
Boston, MA  02110-1301
USA
***************************************************************************/

var lessspamplease = {
  
  _prefManager:Components.classes["@mozilla.org/preferences-service;1"]
                         .getService(Components.interfaces.nsIPrefService)
                         .getBranch("extensions.lessspamplease."),
  
  _providers: Array(),
  
  _mailboxes: Array(),
  
  _defaultProvider: "yopmail",
  
  strings: null,
  
  // ------------------------------------------------------------------------
  log: function(txt) {
    //Components.utils.reportError("[lessSpam] " + txt);
    dump("[lessSpam] " + txt + "\n");
  },
  
  // ------------------------------------------------------------------------
  shortText: function(txt) {
    return txt.charAt(0) + txt.length
  },
  
  // ------------------------------------------------------------------------
  scrambleText: function(txt) {
    // First, keep only alphabetical characters
    var a = txt.replace(/[^a-zA-Z]/g, "");
    if (a.length < 5) a += a;
    // then apply a ROT13 on the string
    a = a.replace(/[a-zA-Z]/g, function(c){
             return String.fromCharCode((c <= "Z" ? 90 : 122) >= (c = c.charCodeAt(0) + 13) ? c : c - 26);
             });
    // Then, sort the string
    return a.split("").sort().join("");
  },
  
  // ------------------------------------------------------------------------
  onFirefoxLoad: function() {
    this._providers['yopmail']    = ["yopmail.fr",
                                     "yopmail.net",
                                     "cool.fr.nf",
                                     "jetable.fr.nf",
                                     "nospam.ze.tc",
                                     "nomail.xl.cx",
                                     "mega.zik.dj",
                                     "speed.1s.fr",
                                     "courriel.fr.nf",
                                     "moncourrier.fr.nf",
                                     "monemail.fr.nf",
                                     "monmail.fr.nf",
                                     "mail.mezimages.net"];
    this._providers['humaility']  = ["humaility.com",
                                     "ignoremail.com",
                                     "bugmenever.com",
                                     "losemymail.com",
                                     "nobugmail.com",
                                     "nobuma.com",
                                     "nabuma.com"];
    this._providers['mailinator'] = ["mailinator.com",
                                     "binkmail.com",
                                     "bobmail.info",
                                     "zippymail.info",
                                     "thisisnotmyrealemail.com",
                                     "safetymail.info",
                                     "suremail.info"];
    this._providers['trashmail'] = ["trash-mail.com"];
    this._mailboxes= {'yopmail':   'http://www.yopmail.com?%%%',
                      'humaility': 'http://humaility.com/l?email=%%%',
                      'mailinator':'http://www.mailinator.com/maildir.jsp?email=%%%',
                      'trashmail':'http://www.trash-mail.com/index.php?mail=%%%'};
    
    this.initialized = true;
    this.strings = document.getElementById("lessspamplease-strings");
    document.getElementById("contentAreaContextMenu")
            .addEventListener("popupshowing", function(e) {lessspamplease.showFirefoxContextMenu(e);}, false);
    document.getElementById("contentAreaContextMenu")
            .addEventListener("popupshowing", function(e) {lessspamplease.showFirefoxContextMenu(e);}, false);
  },
  
  // ------------------------------------------------------------------------
  showFirefoxContextMenu: function(event) {
    // show or hide the menuitem based on what the context menu is on
    document.getElementById("context-lessspamplease").hidden = !gContextMenu.onTextInput;
    document.getElementById("context-lessspampleaselink").hidden = (this._prefManager.getBoolPref("hidedirectaccess") || document.popupNode.ownerDocument.location == "about:blank");
  },
  
  // ------------------------------------------------------------------------
  onMenuItemOpenCommand: function() {
    var prefix = this._prefManager.getCharPref("userprefix");
    if (prefix == "") {
      alert(this.strings.getString("noprefix"));
      window.openDialog("chrome://lessspamplease/content/options.xul", "",
              "chrome, dialog, modal, resizable=no").focus();
      return;
    }
    var provider = this._prefManager.getCharPref("mailprovider");
    var formatOption = this._prefManager.getIntPref("addresstype");
    var idx = 0;
    var site = "";
    var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
    // Host of current page
    var host = ioService.newURI(document.popupNode.ownerDocument.location, null, null).host;
    // Get domain name for that host:
    var firstDot = host.indexOf(".");
    var lastDot = host.lastIndexOf('.');
    if (firstDot != lastDot) { // Ther is a subdomain
      idx = host.length - (firstDot + 1);
      site = host.substring(firstDot + 1, lastDot);
    } else {
      idx = host.length;
      site = host.substring(0, lastDot);
    }
    if (! provider in this._providers) {
      provider = this._defaultProvider;
    }
    // Buid mail address left value
    switch (formatOption) {
      case 1: // Plain format
        break;
      case 2:
        site = this.shortText(site);
        break;
      case 3:
        site = this.scrambleText(site);
        break;
    }
    var mail = prefix + "." + site;
    gBrowser.selectedTab = gBrowser.addTab(this._mailboxes[provider].replace('%%%', mail));
  },

  // ------------------------------------------------------------------------
  onMenuItemCommand: function(event) {
    var elt = document.popupNode;
    var prefix = this._prefManager.getCharPref("userprefix");
    if (prefix == "") {
      alert(this.strings.getString("noprefix"));
      window.openDialog("chrome://lessspamplease/content/options.xul", "",
              "chrome, dialog, modal, resizable=no").focus();
      return;
    }
    var provider = this._prefManager.getCharPref("mailprovider");
    var formatOption = this._prefManager.getIntPref("addresstype");
    var domain=  "";
    var site = "";
    var idx = 0;
    var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
    // Host of current page
    var host = ioService.newURI(elt.ownerDocument.location, null, null).host;
    // Get domain name for that host:
    var firstDot = host.indexOf(".");
    var lastDot = host.lastIndexOf('.');
    if (firstDot != lastDot) {
      idx = host.length - (firstDot + 1);
      site = host.substring(firstDot + 1, lastDot);
    } else {
      idx = host.length;
      site = host.substring(0, lastDot);
    }
    if (provider in this._providers) {
      idx = idx % this._providers[provider].length;
    } else {
      provider = this._defaultProvider;
    }
    // Get an alternate mail domain for that host:
    domain= this._providers[provider][idx];
    // Buid mail address
    switch (formatOption) {
      case 1: // Plain format
        break;
      case 2:
        site = this.shortText(site);
        break;
      case 3:
        site = this.scrambleText(site);
        break;
    }
    var mail = prefix + "." + site + "@" + domain;
    if (elt.type == 'textarea') {
      if (elt.textLength == elt.selectionStart) elt.value = elt.value + mail;
      else elt.value = elt.value.substring(0, elt.selectionStart) + mail + elt.value.substring(elt.selectionEnd, elt.textLength);
    } else { // input fields
      elt.value = mail;
    }
  }
  
};

window.addEventListener("load", function(e) { lessspamplease.onFirefoxLoad(e); }, false);